/* CREATE ALIAS a123 FOR DATABASE test-database NO-ERROR. */
CREATE ALIAS a123 FOR DATABASE p2j_test NO-ERROR.


DEF VAR i AS INT.
REPEAT i = 1 TO NUM-ALIASES:
    DISPLAY ALIAS(i) LABEL "Alias"
    LDBNAME(ALIAS(i)) LABEL "Logical Database".
END.

PAUSE.


/*CONNECT "p2j_test.db" -1 NO-ERROR.*/

/* FORM "By SessionId:" SKIP WITH NO-LABELS FRAME f1. */
/* FORM "By Alias or LogialName:" SKIP WITH NO-LABELS FRAME f2. */

RUN printDbInfo (INPUT ?, INPUT ?).
RUN printDbInfo (INPUT 0, INPUT ?).
RUN printDbInfo (INPUT 1, INPUT ?).
RUN printDbInfo (INPUT 2, INPUT ?).
RUN printDbInfo (INPUT 3, INPUT ?).
RUN printDbInfo (INPUT ?, INPUT "").
RUN printDbInfo (INPUT ?, INPUT "p2j_test").
RUN printDbInfo (INPUT ?, INPUT "DICTDB"). /* 1st conencted db */
RUN printDbInfo (INPUT ?, INPUT "FTDB").
RUN printDbInfo (INPUT ?, INPUT "test-database").
RUN printDbInfo (INPUT ?, INPUT "a123").

/*DISCONNECT p2j_test.*/

PAUSE MESSAGE "Finished running the all tests ...".
/* end of test program */


FUNCTION to-char RETURNS CHARACTER (INPUT p1 AS CHARACTER).
    RETURN IF p1 = ? THEN "?" ELSE p1.
END FUNCTION.


PROCEDURE printDbInfo:
    DEFINE INPUT PARAMETER p1 AS INTEGER.
    DEFINE INPUT PARAMETER p2 AS CHARACTER FORMAT "x(12)".

    DEFINE VARIABLE b AS CHARACTER FORMAT "x(80)".
    
    IF p1 = ? THEN
        /* 1st form of dbparam call: session id */
        b = "[" + to-char(p2) + "]: " + to-char(DBPARAM(p2)).
    ELSE
        /* 2nd form of dbparam call: alias or logical name */
        b = STRING(p1) + ": " + to-char(DBPARAM(p1)).
    
    DISPLAY SUBSTRING(b, 1, 70) FORMAT "x(70)"
            SUBSTRING(b, 71, 70) FORMAT "x(70)" SKIP 
        WITH NO-LABELS NO-BOX.
END PROCEDURE.
